; 
; 
; 

	OPT	c
	OPT	l

;
; L0021 values
; 
; C = (N * 0.625) - 5
; 
; 96  == 55c, 131f
; 112 == 65c, 149f
; 128 == 75c, 167f
; 

; 
; HiWay SA has two qualifiers:
; 
; 	D027: Minimum mph * 3.2
; 	D028: secs > min mph
; 
; This code for HiWay fuel adds coolant as
; a third qualifier for the HiWay SA.
; 
; Once the HiWay SA is enabled, HiWay fuel
; will be enabled with a map qualifier.
; 


	ORG	$DB40		; 48 bytes avail

HIWAYF:
; 
; optional coolant term, also kills HiWay SA
; 

	LDAA	$22		; coolant, std, -5c to 155c
	CMPA	#128		; 128 = 75c, 167f
	BHI	DOREST		; bra if coolant > threshold
	CLR	$7A		; clear hi-way timer
	BRA	NOWAY

DOREST:
;	LDAA	$08		; status
;	BPL	NOWAY		; no hiway unless cls lp ok

	LDAA	$7A		; timer, hiway spark
	CMPA	$D028		; threshold (same as hiway SA)
	BLO	NOWAY		; bra if timer < threshold
	LDAA	$27		; map
	CMPA	#175		; ~75 Kpa (kpa = N * .3125 + 20)
	BHI	NOWAY		; bra if map > threshold

;
; We are good to go. . .
;

	LDAB	$3		; status byte
	ORAB	#$02		; set active
	STAB	$3		; save status
	LSRA			; map /=2, now by 10's
	LDX	#$DB67		; new table address
	JSR	$FBA8		; 2d lookup
	BRA	JAWAY		; have at it

;	FCB	$FF

;
; HiWay fuel AFR table
;
  	ORG	$DB67
  	FCB	161		; 20 Kpa
  	FCB	161		; 30 Kpa
  	FCB	161		; 40 Kpa
  	FCB	159		; 50 Kpa
  	FCB	156		; 60 Kpa
  	FCB	155		; 70 Kpa
  	FCB	154		; 80 Kpa
  	FCB	154		; 90 Kpa
  	FCB	154		; 100 Kpa


	ORG	$DB70
NOWAY:

	ORG	$DB78
JAWAY:


; eof ;
